/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MOTIEVOLCONT                                             */
/* Tabela : MOTIEVOLCONT                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 28/02/2007 - Rejane P. Leite                                               */
/*                                                                            */
/******************************************************************************/
CREATE OR REPLACE TRIGGER DTULTATU_MOTIEVOLCONT
BEFORE INSERT OR UPDATE OR DELETE
ON MOTIEVOLCONT FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMOEC := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDMOTIEVOCON,0 ) <> NVL(:NEW.CDMOTIEVOCON,0)) OR
         (NVL(:OLD.NMMOTIEVOCON,0 ) <> NVL(:NEW.NMMOTIEVOCON,0)) THEN
         :NEW.DTULTATUMOEC := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MOTIEVOLCONT', '','CDMOTIEVOCON='||:OLD.CDMOTIEVOCON||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MOTIEVOLCONT MODIFY DTULTATUMOEC DEFAULT SYSDATE
/


-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_MOTIEVOLCONT','5.03.010'); END;
/

