/* Tabela MAPIMPRLOJA: TABELA DE MAPEAMENTO DE IMPRESSORAS */
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela MAPIMPRLOJA*/
/* Objetivo: Gerar um log que vai registrar as alteraes na MAPIMPRLOJA,
             utilizando a tabela de Logs de Operaes do VND*/

CREATE OR REPLACE TRIGGER LOG_VND_MAPIMPRLOJA
AFTER DELETE OR INSERT OR UPDATE
ON MAPIMPRLOJA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN

	  IF NVL(:NEW.CDFILIAL,'NULL') <> NVL(:OLD.CDFILIAL,'NULL') THEN 
         V_DESC := 'Filial ' || '' || NVL(:NEW.CDFILIAL,'' );
      END IF;
      IF NVL(:NEW.CDLOJA,'NULL') <> NVL(:OLD.CDLOJA,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Loja ' || '' || NVL(:NEW.CDLOJA,''  );
      END IF;
      IF NVL(:NEW.CDPORTAIMPR,'NULL') <> NVL(:OLD.CDPORTAIMPR,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Cd Porta Impressora ' || '' || NVL(:NEW.CDPORTAIMPR,''  );
      END IF;
      IF NVL(:NEW.DSENDPORTA,'NULL') <> NVL(:OLD.DSENDPORTA,'NULL') THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Descrio End Porta ' || '' || NVL(:NEW.DSENDPORTA,''  );
      END IF;
	  IF NVL(:NEW.DTULTATU,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTULTATU,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
         V_DESC := NVL(V_DESC, '') || ' ' || 'Data Ult Atualizao ' || '' || NVL(:NEW.DTULTATU,'');
      END IF;

      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDLOJA||:NEW.CDPORTAIMPR;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN

      V_DESC   := 'Filial '               || '' || NVL(:NEW.CDFILIAL,''    )   || ' ' ||
                  'Loja  '                || '' || NVL(:NEW.CDLOJA,''  )       || ' ' ||
                  'Cd Porta Impressora  ' || '' || NVL(:NEW.CDPORTAIMPR,''  )  || ' ' ||
                  'Descrio End Porta  ' || '' || NVL(:NEW.DSENDPORTA,''  )   || ' ' ||
                  'Data Ult Atualizao ' || '' || NVL(:NEW.DTULTATU,'');

      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDLOJA||:NEW.CDPORTAIMPR;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN

      V_DESC   := 'Filial '               || '' || NVL(:OLD.CDFILIAL,''    )   || ' ' ||
                  'Loja  '                || '' || NVL(:OLD.CDLOJA,''  )       || ' ' ||
                  'Cd Porta Impressora  ' || '' || NVL(:OLD.CDPORTAIMPR,''  )  || ' ' ||
                  'Descrio End Porta  ' || '' || NVL(:OLD.DSENDPORTA,''  )   || ' ' ||
                  'Data Ult Atualizao ' || '' || NVL(:OLD.DTULTATU,'');


            V_ITPESQ := :OLD.CDFILIAL||:OLD.CDLOJA||:OLD.CDPORTAIMPR;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND,
       CDFILLOGOPERVND)
   VALUES
      ('MAPIMPRLOJA',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_VND_MAPIMPRLOJA','5.20.001'); END;
/







