import { InstanceService } from '@/services/InstanceService';
import Store from '@/store';
import { DialogServiceCustom } from '@/services/DialogServiceCustom';
import { LoadingService } from '@zeedhi/common';
import { Http } from '@zeedhi/core';
import { AlertServiceCustom } from '@/services/AlertServiceCustom';
import Messages from '@/services/Messages';

export class DMAddSolicitationController {
	private userAuth: any;

	private CDCLIENTE: string = '';

	private PRODUCT_TYPE: string = '';

	public disableUseLicense: boolean = true;

	public disableVersion: boolean = true;

	public disableRelease: boolean = true;

	public disablePatch: boolean = true;

	private PRODUCT_VERSION: string = '';

	private PRODUCT_RELEASE: string = '';

	private CDARVPROD: string = '';

	public async onMountedFormAddCallS() {
		const reportedByAddField = InstanceService.getInstanceZdSelect('reportedByAddS');
		this.userAuth = Store.getters['User/getUser'];
		await reportedByAddField.setValue(this.userAuth.CDOPERADOR, false);
	}

	public async changeSoliOriginAddItemTaskModal(params: any) {
		if (params.component.value) {
			params.component.value = `0000000000${params.component.value}`.slice(-10);
			try {
				const response = await Http.get(`findAllSoliserv?page=1&limit=25&search=${params.component.value}&search_in%5B0%5D=NRSOLISERV`);
				if (!response.data.data[0]) {
					DialogServiceCustom.showError(Messages.ERROR_SOLI_ORI);
					params.component.value = '';
				}
			} catch (e) {
				DialogServiceCustom.showErrorBackend(e);
			}
		}
	}

	public async onChangeClientAddCallModal(params: any) {
		const useLicenseAddS = InstanceService.getInstanceZdSelect('useLicenseAddS');
		if (params.value) {
			this.CDCLIENTE = params.component.value;
			try {
				await useLicenseAddS.datasource.get();
			} catch (e) {
				DialogServiceCustom.showErrorBackend(e);
			}
			this.disableUseLicense = false;
		} else {
			this.disableUseLicense = true;
		}
	}

	public async onChangeVersionSAddCallModal(params: any) {
		const releaseInstance = InstanceService.getInstanceZdSelect('releaseAddS');
		const patchInstance = InstanceService.getInstanceZdSelect('patchAddS');
		if (params.value) {
			this.PRODUCT_VERSION = params.value;
			try {
				const release = await releaseInstance.datasource.get();
				if (release.length === 1) {
					this.disableRelease = true;
					releaseInstance.value = release[0].ID;
					await patchInstance.datasource.get();
				} else {
					this.disableRelease = false;
				}
			} catch (e) {
				DialogServiceCustom.showErrorBackend(e);
			}
		}
	}

	public async onChangeReleaseAddCallModal(params: any) {
		const patchInstance = InstanceService.getInstanceZdSelect('patchAddS');
		if (params.value) {
			this.PRODUCT_RELEASE = params.value;
			try {
				const patch = await patchInstance.datasource.get();
				if (patch.length === 1) {
					this.disablePatch = true;
					patchInstance.value = patch[0].ID;
				} else {
					this.disablePatch = false;
				}
			} catch (e) {
				DialogServiceCustom.showErrorBackend(e);
			}
		}
	}

	public async onChangeProductTypeAddCallModal(params: any) {
		const versionSInstance = InstanceService.getInstanceZdSelect('versionAddS');
		const releaseInstance = InstanceService.getInstanceZdSelect('releaseAddS');
		// const patchInstance = InstanceService.getInstanceZdSelect('patchAddS');
		if (params.value) {
			this.PRODUCT_TYPE = params.component.value;
			this.CDARVPROD = params.component.selectedData.CDARVPROD;
			try {
				const version = await versionSInstance.datasource.get();
				if (version.length === 1) {
					this.disableVersion = true;
					versionSInstance.value = version[0].ID;
					this.PRODUCT_VERSION = version[0].ID;
					const release = await releaseInstance.datasource.get();
					if (release.length === 1) {
						this.disableRelease = true;
						releaseInstance.value = release[0].ID;
						this.PRODUCT_RELEASE = release[0].ID;
						// await patchInstance.datasource.get();
					} else {
						this.disableRelease = false;
					}
				} else {
					this.disableVersion = false;
				}
			} catch (e) {
				DialogServiceCustom.showErrorBackend(e);
			}
		} else {
			this.disableVersion = true;
			this.disableRelease = true;
			this.disablePatch = true;
		}
	}

	public async saveAddCall() {
		const addCallFormInstance = InstanceService.getInstanceZdForm('formNewCallS');
		const checkValidation = addCallFormInstance.validate();
		if (checkValidation) {
			const callGridInstance = InstanceService.getInstanceTekGrid('gridDemandManagement');
			const customerInstance = InstanceService.getInstanceZdSelect('customerAddS');
			const productInstance = InstanceService.getInstanceZdSelect('productAddCall');
			LoadingService.show();
				const productTypeInstance = InstanceService.getInstanceZdSelect('productTypeAddS');
				const versionSInstance = InstanceService.getInstanceZdSelect('versionAddS');
				try {
					await Http.post('/productCallSave', {
						REFERENCE: addCallFormInstance.value.referenceAddS,
						PRODUCT_TYPE_NAME: productTypeInstance.selectedData.LABEL,
						MENU_ITEM: '',
						MENU_VERSION: '',
						NMRAZSOCCLIE: customerInstance.selectedData.NMRAZSOCCLIE,
						CALL_LABELS: addCallFormInstance.value.labelsAddS,
						DESCRIPTION: addCallFormInstance.value.descriptionAddS,
						REPORTED_BY: addCallFormInstance.value.reportedByAddS,
						CDCLIENTE: customerInstance.selectedData.CDCLIENTE,
						PLATAFORMA: 'DELPHI',
						PROJECT_ID: productInstance.selectedData.PRODUCT_FILTER_ID,
						SGSISTEMA: productInstance.selectedData.SGSISTEMA,
						TYPE: 'S',
						PRODUCT: versionSInstance.selectValue.CDPRODCOMP,
						PRODUCT_VERSION: addCallFormInstance.value.versionAddS,
						PRODUCT_RELEASE: addCallFormInstance.value.releaseAddS,
						PRODUCT_TYPE: addCallFormInstance.value.productTypeAddS,
						CDARVPROD: productTypeInstance.selectedData.CDARVPROD,
						CLASSIFICATION: addCallFormInstance.value.categoryAddS,
						PRODUCT_PATCH: addCallFormInstance.value.patchAddS,
						USE_LICENSE: addCallFormInstance.value.useLicenseAddS,
						APPOINTMENT_DATE: addCallFormInstance.value.appointmentDateAddS,
						NRSOLIORIG: addCallFormInstance.value.soliOriginAddS,
					});
					LoadingService.hide();
					AlertServiceCustom.defaultSaveSuccessAlert();
					const cancelAddButtonS = InstanceService.getInstanceAny('cancelAddButtonS');
					cancelAddButtonS.events.click();
					// this.closeAddModalDemandManagementGrid();
					await callGridInstance.datasource.get();
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
				}
			LoadingService.hide();
		}
	}
}
